local addonName, addonTable = ...;
local _, _, _, tocversion = GetBuildInfo()
local gsub = _G.string.gsub
local match = _G.string.match
local Fun = {}
-------------
function PIGCopyTable(OldTable)
	local function PIGCopyfun(old,new)
		for k,v in pairs(old) do
	    	if type(v)=="table" then
	    		new[k]={}
	    		PIGCopyfun(v,new[k])
	    	else
	    		new[k]=v
	    	end
	    end
	end
    local NewTable = {}
    PIGCopyfun(OldTable,NewTable)
    return NewTable
end
function table.removekey(table, key)
    local element = table[key]
    table[key] = nil
    return element
end
function PIG_print(msg)
	print("|cff00FFFF!Pig:|r|cffFFFF00"..msg.."|r");
end
----
function PIGEnable(self)
	self:Enable() self.Text:SetTextColor(1, 1, 1, 1) 
end
function PIGDisable(self)
	self:Disable() self.Text:SetTextColor(0.4, 0.4, 0.4, 1) 
end
--获取背包信息
function PIGGetContainerIDlink(bag, slot)
	local ItemInfo = C_Container.GetContainerItemInfo(bag, slot)
	if ItemInfo then
		return ItemInfo.itemID, ItemInfo.hyperlink, ItemInfo.iconFileID, ItemInfo.stackCount, ItemInfo.quality, ItemInfo.hasNoValue
	end
	return false
end
--格式化物品信息
function PIG_ItemLink(itemLink)
	--cffffffff|Hitem 
	--:1 itemID
	--:2 enchantID 永久附魔
	--:3_gemID1，
	--:4_gemID2:5gemID3，:6_gemID4 
	--:7 suffixID 随机项目后缀，类似“雄鹰之，耐力之” 
	--:8 uniqueID 与项目的特定实例有关的数据，不再使用
	--:9 linkLevel 提供链接玩家级别，用于在适当的级别上渲染缩放传家 
	--:10 specializationID 提供此链接玩家专精id。用来显示装备上主 
	--:11 不再使用
	--:12_s来源(任务奖励/英雄副本/团队) 
	--:13 --
	--"需要重置8/9/10
	-- local qianbu = itemLink:match("(|?c?f?f?%x*|?Hitem:?%d+:?%d*:?%d*:?%d*:?%d*:?%d*:?%d*:?).+")
	-- --print(qianbu, d1, d2,d3,d4,d5,d6,d7,d8,d9)
	-- --print(qianbu:gsub("|","||"))
	-- local hounbu = itemLink:match("|?c?f?f?%x*|?Hitem:?%d+:?%d*:?%d*:?%d*:?%d*:?%d*:?%d*:?%d*:?%d*:?%d*:?%d*:?(.+)")
	-- --print(hounbu, d1, d2,d3,d4,d5,d6,d7,d8,d9)
	-- --print(hounbu:gsub("|","||"))
	-- local hebingLink = qianbu.."::::"..hounbu
	--local Linkxx = "|cffe6cc80|Hitem:128825::140844:140839:152044::::53:257::9:2:739:1522:2:8:749:24:1:3:3520:1472:3337:3:3520:1472:3337:3:3610:1472:3528::|h[T'uure, Beacon of the Naaru]|h|r"
	-- print(Linkxx:gsub("|","||"))
	-- --local tihuanhou = Linkxx:gsub("|cff%w%w%w%w%w%w|Hitem:%d+:%d*:%d*:%d*:%d*:%d*:%d*:(%d*:%d*:%d*).+","")
	-- local tihuanhou,qeqe = Linkxx:gsub("|cff%w%w%w%w%w%w|H(item:%d+:?%d*:?%d*:?%d*:?%d*:?%d*:?%-?%d*:?)%d*:?%d*:?%d*(:?%d*:?%d*:?%d*:?%d*:?%d*:?%d*:?%d*:?)|h%[.+","%1::%2")
	-- print(tihuanhou)
	-- print(qeqe)
	--print(tihuanhou:gsub("|","||"))
	--return hebingLink
end
--print(GetSpecializationInfoByID(256))
--PIG_ItemLink(itemLink)
--发送消息
function PIGSendChatRaidParty(txt)
	--SendChatMessage(txt, "SAY");--测试
	if IsInRaid() then
		SendChatMessage(txt, "RAID");
	elseif IsInGroup() then
		SendChatMessage(txt, "PARTY");
	end
end
function PIGSendAddonMessage(biaotou,txt)
	--C_ChatInfo.SendAddonMessage(biaotou,txt,"SAY");--测试
	if IsInRaid() then
		C_ChatInfo.SendAddonMessage(biaotou,txt,"RAID")
	elseif IsInGroup() then
		C_ChatInfo.SendAddonMessage(biaotou,txt,"PARTY")
	end
end
--获取PIG频道
local ChatpindaoMAX = 5
Fun.ChatpindaoMAX=ChatpindaoMAX
local function huoqubianhao(Name)
	local channel,channelName= GetChannelName(Name)
	if channelName then
		return channel
	else
		return 0
	end
end
function Fun.GetPIGID(chname)
	local chname = chname or "PIG"
	local cunzaihao = huoqubianhao(chname)
	if cunzaihao>0 then
		return cunzaihao
	else
		for x=1,ChatpindaoMAX do
			local newpindaoname = chname..x
			local cunzaihao = huoqubianhao(newpindaoname)
			if cunzaihao>0 then
				return cunzaihao
			end
		end
	end
	return 0
end
--根据等级计算单价
function Fun.Get_LvDanjia(lv,fbName,danjiaList)
	if fbName~="无" then
		for id = 1, 4, 1 do
			if danjiaList[id][1]>0 then
				if lv>=danjiaList[id][1] and lv<=danjiaList[id][2] then
					return danjiaList[id][3]
				end
			end
		end
	end
	return 0
end
--获取队伍等级文本
function Fun.Get_GroupLV(MsgNr)
	local MsgNr=""
	if IsInGroup() then
		local numgroup = GetNumSubgroupMembers()
		if numgroup>0 then
			for id=1,numgroup do
				local dengjiKk = UnitLevel("Party"..id);
				if id==numgroup then
					MsgNr=MsgNr..dengjiKk;
				else
					MsgNr=MsgNr..dengjiKk..",";
				end
			end
			MsgNr=MsgNr;
		end
	end
	return MsgNr
end
--获取所带副本级别单价文本
function Fun.Get_LvDanjiaTxt(MsgNr)
	local MsgNr = ""
	local fbName=PIGA_Per["daiben"]["fubenName"]
	local danjiaList=PIGA_Per["daiben"]["LV_danjia"][fbName]
	for id = 1, 4, 1 do
		local kaishiLV =danjiaList[id][1]
		local jieshuLV =danjiaList[id][2]
		local jiageG =danjiaList[id][3]
		if kaishiLV>0 and jieshuLV>0 then
			if jiageG>0 then
				MsgNr=MsgNr.."<"..kaishiLV.."-"..jieshuLV..">"..jiageG.."G;"
			else
				MsgNr=MsgNr.."<"..kaishiLV.."-"..jieshuLV..">"..L["LIB_FREE"]
			end
		end
	end
	return MsgNr
end
--获取设置的最小和最大级别
function Fun.Get_LVminmax(fbName,danjiaList)
	local min,max = nil,nil
	for id = 1, 4, 1 do
		local kaishiLV =danjiaList[id][1]
		local jieshuLV =danjiaList[id][2]
		if kaishiLV>0 and jieshuLV>0 then
			if min then
				if kaishiLV<min then
					min=kaishiLV
				end
			else
				min=kaishiLV
			end
			if max then
				if jieshuLV>max then
					max=jieshuLV
				end
			else
				max=jieshuLV
			end
		end
	end
	local min,max = min or 0,max or 0
	return min,max
end
------------------
addonTable.Fun=Fun